%define anolis_release 6

%global username    saslauth

%global bootstrap_cyrus_sasl 0

Name: cyrus-sasl
Version: 2.1.28
Release: %{anolis_release}%{?dist}
Summary: The Cyrus SASL library
License: BSD with advertising
URL: https://www.cyrusimap.org/sasl/

Source0: https://github.com/cyrusimap/%{name}/releases/download/%{name}-%{version}/%{name}-%{version}.tar.gz
Source3: saslauth.sysusers
Source5: saslauthd.service
Source7: sasl-mechlist.c
Source9: saslauthd.sysconfig
Source11: autogen.sh





BuildRequires: make, autoconf, automake, libtool, gdbm-devel, groff
BuildRequires: krb5-devel >= 1.2.2, openssl-devel, pam-devel, pkgconfig
BuildRequires: mariadb-connector-c-devel, libpq-devel, zlib-devel
%if ! %{bootstrap_cyrus_sasl}
BuildRequires: openldap-devel
%endif
BuildRequires: nss_wrapper socket_wrapper krb5-server

Requires(pre): /usr/sbin/useradd /usr/sbin/groupadd
Requires(postun): /usr/sbin/userdel /usr/sbin/groupdel
Requires: /sbin/nologin
Requires: %{name}-lib = %{version}-%{release}

Provides: user(%username)
Provides: group(%username)

Patch11: cyrus-sasl-2.1.25-no_rpath.patch
Patch15: cyrus-sasl-2.1.20-saslauthd.conf-path.patch
Patch23: cyrus-sasl-2.1.23-man.patch
Patch24: cyrus-sasl-2.1.21-sizes.patch
Patch49: cyrus-sasl-2.1.26-md5global.patch

Patch101: cyrus-sasl-2.1.27-Add-basic-test-infrastructure.patch
Patch102: cyrus-sasl-2.1.27-Add-Channel-Binding-support-for-GSSAPI-GSS-SPNEGO.patch
Patch106: cyrus-sasl-2.1.27-nostrncpy.patch
Patch107: cyrus-sasl-2.1.27-more-tests.patch
Patch108: cyrus-sasl-2.1.27-Add-support-for-setting-max-ssf-0-to-GSS-SPNEGO.patch
Patch500: cyrus-sasl-2.1.27-coverity.patch
Patch501: cyrus-sasl-2.1.27-cumulative-digestmd5.patch
Patch502: cyrus-sasl-2.1.27-cumulative-ossl3.patch


%description
Simple Authentication and Security Layer (SASL) is a specification
that describes how authentication mechanisms can be plugged into an
application protocol on the wire. Cyrus SASL is an implementation of
SASL that makes it easy for application developers to integrate
authentication mechanisms into their application in a generic way.

The %{name} package contains the Cyrus implementation of SASL.
SASL is the Simple Authentication and Security Layer, a method for
adding authentication support to connection-based protocols.

%package lib
Summary: Shared libraries needed by applications which use %{name}

%description lib
The %{name}-lib package contains shared libraries which are needed by
applications which use the %{name} library.

%package gssapi
Summary: GSSAPI authentication support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description gssapi
The %{name}-gssapi package contains the %{name} plugins which
support GSSAPI authentication. GSSAPI is commonly used for Kerberos
authentication.

%package plain
Summary: PLAIN and LOGIN authentication support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description plain
The %{name}-plain package contains the %{name} plugins which support
PLAIN and LOGIN authentication schemes.

%package md5
Summary: CRAM-MD5 and DIGEST-MD5 authentication support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description md5
The %{name}-md5 package contains the %{name} plugins which support
CRAM-MD5 and DIGEST-MD5 authentication schemes.

%package ntlm
Summary: NTLM authentication support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description ntlm
The %{name}-ntlm package contains the %{name} plugin which supports
the NTLM authentication scheme.

%package sql
Summary: SQL auxprop support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description sql
The %{name}-sql package contains the %{name} plugin which supports
using a RDBMS for storing shared secrets.

%if ! %{bootstrap_cyrus_sasl}
%package ldap
Summary: LDAP auxprop support for %{name}
Requires: %{name}-lib = %{version}-%{release}

%description ldap
The %{name}-ldap package contains the %{name} plugin which supports using
a directory server, accessed using LDAP, for storing shared secrets.
%endif

%package scram
Requires: %{name}-lib = %{version}-%{release}
Summary: SCRAM auxprop support for %{name}

%description scram
The %{name}-scram package contains the %{name} plugin which supports
the SCRAM authentication scheme.

%package gs2
Requires: %{name}-lib = %{version}-%{release}
Summary: GS2 support for %{name}

%description gs2
The %{name}-gs2 package contains the %{name} plugin which supports
the GS2 authentication scheme.

%package devel
Summary: Files needed for developing applications with Cyrus SASL
Requires: %{name}-lib = %{version}-%{release}
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains files needed for developing and
compiling applications which use the Cyrus SASL library.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n cyrus-sasl-%{version}

find %{_builddir}/%{name}-%{version} -maxdepth 1 -name 'dlcompat-*' -exec rm -rf {} \;

%build
cp %{SOURCE11} ./
rm configure aclocal.m4 config/ltmain.sh Makefile.in
export NOCONFIGURE=yes
sh autogen.sh

CFLAGS="$RPM_OPT_FLAGS $(mysql_config --include) $CFLAGS $CPPFLAGS -fPIC -pie -Wl,-z,relro -Wl,-z,now"; export CFLAGS

echo "$CFLAGS"
echo "$CPPFLAGS"
echo "$LDFLAGS"

%configure \
        --enable-shared --disable-static \
        --with-plugindir=%{_libdir}/sasl2 \
        --with-configdir=%{_libdir}/sasl2:%{_sysconfdir}/sasl2 \
        --disable-krb4 \
        --enable-gssapi \
        --with-gss_impl=mit \
        --with-rc4 \
        --with-dblib=gdbm \
        --with-saslauthd=/run/saslauthd --without-pwcheck \
%if ! %{bootstrap_cyrus_sasl}
        --with-ldap \
%endif
        --with-devrandom=/dev/urandom \
        --enable-anon \
        --enable-cram \
        --enable-digest \
        --enable-ntlm \
        --enable-plain \
        --enable-login \
        --enable-alwaystrue \
        --enable-httpform \
        --disable-otp \
%if ! %{bootstrap_cyrus_sasl}
        --enable-ldapdb \
%endif
        --enable-sql --with-mysql=yes --with-pgsql=yes \
        --without-sqlite \
        --enable-auth-sasldb \
        "$@"
%make_build sasldir=%{_libdir}/sasl2
%make_build -C saslauthd testsaslauthd
%make_build -C sample

pushd lib
../libtool --mode=link %{__cc} -o sasl2-shared-mechlist -I../include $CFLAGS %{SOURCE7} $LDFLAGS ./libsasl2.la


%install
%make_install
%make_install -C plugins

install -m755 -d %{buildroot}%{_bindir}
./libtool --mode=install \
install -m755 sample/client %{buildroot}%{_bindir}/sasl2-sample-client
./libtool --mode=install \
install -m755 sample/server %{buildroot}%{_bindir}/sasl2-sample-server
./libtool --mode=install \
install -m755 saslauthd/testsaslauthd %{buildroot}%{_sbindir}/testsaslauthd

install -m755 -d %{buildroot}%{_mandir}/man8/
install -m644 -p saslauthd/saslauthd.mdoc %{buildroot}%{_mandir}/man8/saslauthd.8
install -m644 -p saslauthd/testsaslauthd.8 %{buildroot}%{_mandir}/man8/testsaslauthd.8

install -d -m755 %{buildroot}/%{_unitdir} %{buildroot}/etc/sysconfig
install -m644 -p %{SOURCE5} %{buildroot}/%{_unitdir}/saslauthd.service
install -m644 -p %{SOURCE9} %{buildroot}/etc/sysconfig/saslauthd

install -m755 -d %{buildroot}/%{_sysconfdir}/sasl2
install -m755 -d %{buildroot}/%{_libdir}/sasl2

./libtool --mode=install \
install -m755 lib/sasl2-shared-mechlist %{buildroot}/%{_sbindir}/
install -p -D -m 0644 %{SOURCE3} %{buildroot}%{_sysusersdir}/cyrus-sasl.conf

rm -f %{buildroot}%{_libdir}/sasl2/libotp.*
rm -f %{buildroot}%{_libdir}/sasl2/*.a
rm -f %{buildroot}%{_mandir}/cat8/saslauthd.8

%check
%make_build check

%pre
%sysusers_create_compat %{SOURCE3}

%post
%systemd_post saslauthd.service

%preun
%systemd_preun saslauthd.service

%postun
%systemd_postun_with_restart saslauthd.service

%files
%{_mandir}/man8/*
%{_sbindir}/pluginviewer
%{_sbindir}/saslauthd
%{_sbindir}/testsaslauthd
%config(noreplace) /etc/sysconfig/saslauthd
%{_unitdir}/saslauthd.service
%ghost /run/saslauthd
%{_sysusersdir}/cyrus-sasl.conf

%files lib
%license COPYING
%{_libdir}/libsasl*.so.*
%dir %{_sysconfdir}/sasl2
%dir %{_libdir}/sasl2
%{_libdir}/sasl2/*anonymous*.so*
%{_libdir}/sasl2/*sasldb*.so*
%{_sbindir}/saslpasswd2
%{_sbindir}/sasldblistusers2

%files plain
%{_libdir}/sasl2/*plain*.so*
%{_libdir}/sasl2/*login*.so*

%if ! %{bootstrap_cyrus_sasl}
%files ldap
%{_libdir}/sasl2/*ldapdb*.so*
%endif

%files md5
%{_libdir}/sasl2/*crammd5*.so*
%{_libdir}/sasl2/*digestmd5*.so*

%files ntlm
%{_libdir}/sasl2/*ntlm*.so*

%files sql
%{_libdir}/sasl2/*sql*.so*

%files gssapi
%{_libdir}/sasl2/*gssapi*.so*

%files scram
%{_libdir}/sasl2/libscram.so*

%files gs2
%{_libdir}/sasl2/libgs2.so*

%files devel
%{_bindir}/sasl2-sample-client
%{_bindir}/sasl2-sample-server
%{_includedir}/*
%{_libdir}/libsasl*.*so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*
%{_sbindir}/sasl2-shared-mechlist

%files doc
%doc saslauthd/LDAP_SASLAUTHD
%doc README INSTALL.TXT ChangeLog AUTHORS

%changelog
* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> -2.1.28-6
- Optimize spec file

* Sat Mar 4 2023 Funda Wang <fundawang@yeah.net> - 2.1.28-5
- Add various patches
 
* Fri Feb 10 2023 happy_orange <songnannan@linux.alibaba.com> - 2.1.28-4
- add doc package 

* Tue Mar 22 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.28-3
- remove dependency with libdb

* Wed Mar 16 2022 Su Lifan <su-lifan@linux.alibaba.com> - 2.1.28-2
- Fix user/group requiring and providing infomation

* Fri Mar 11 2022 Su Lifan <su-lifan@linux.alibaba.com> - 2.1.28-1
- Initial packaging for Anolis OS 23
